#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Data.OleDb;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;

public partial class ToggleDataSource : System.Web.UI.Page
{
 
  public void Page_Init(object sender, System.EventArgs e)
  {
    // In pages where grid could be bound to multiple data sources,
    // it's better to not set properties on the TableDescriptor in the aspx.
    // Instead it's recommended to set the properties on the TableDescriptor manually
    // whenever the DataSourceID changes.
    // For the first page load:

    this.EmployeesDetails.DataFile = Server.MapPath("App_Data//NWind.MDB");
    this.CustomersDetails.DataFile = Server.MapPath("App_Data//NWind.MDB");
    
    //

    DatasourceList.Attributes.Add("OnChange", "getSelectedIndex();");
    if (this.Page.IsPostBack == false && this.Page.IsCallback == false)
    {
      this.ResetTableDescriptor();
      
    }

    this.GridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(GridGroupingControl1_QueryCellStyleInfo);
    this.GridGroupingControl1.DataBind();
    ShowFilter();
    this.GridGroupingControl1.CurrentRecordContextChange += new CurrentRecordContextChangeEventHandler(GridGroupingControl1_CurrentRecordContextChange);
    
  }

    void GridGroupingControl1_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
    {
        if (e.Action == CurrentRecordAction.BeginEditCalled)
        {
            this.GridGroupingControl1.TableDescriptor.VisibleColumns.Remove("EmployeeID");
        }
        if (e.Action == CurrentRecordAction.EndEditComplete)
        {
            this.GridGroupingControl1.TableDescriptor.VisibleColumns.Add("EmployeeID");
        }
    }

    void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
    {

        //this.GridGroupingControl1.TableDescriptor.VisibleColumns.Remove("EmployeeID");
        //Look for the RecordField and AlternateField Cell.
        if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell)
        {
            //Look for the Column Name "Name of the Column specified" in the GridGroupingControl when it get rendered
            if (e.TableCellIdentity.Column.Name == "EmployeeID")
            {
                //Changes the EditItem template of the column specified as DropDownListBox 
                CheckBox chkbox = new CheckBox();

                //Here we adding the DropDownListBox programatically using ITemplate Interface
                chkbox.Text = "111";
                TemplateClass mytemp = new TemplateClass(chkbox);
                e.TableCellIdentity.Column.EditItemTemplate = mytemp;
            }

        }

    }
    public class TemplateClass : ITemplate
    {
        private Control m_ctrlChildControl = null;
        public TemplateClass(Control ctrlChildControl)
        {
            m_ctrlChildControl = ctrlChildControl;
        }

        public void InstantiateIn(Control container)
        {
            container.Controls.Add(m_ctrlChildControl);
        }
    }


  protected void CallbackPanel1_CallbackRefresh(object sender, Syncfusion.Web.UI.WebControls.Shared.CancellableCallbackEventArgs e)
  {
    this.SetGridDataSource(this.DatasourceList.SelectedValue.ToString());
    ShowFilter(); 
    
  }
    private void ShowFilter()
    {
        //Indicates whether FilterBar are visible for GridGroupingControl
       // this.GridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
        //Gets the collection of columns with Mapping information from underlying datasource
        GridColumnDescriptorCollection descColl = GridGroupingControl1.TableDescriptor.Columns;
        foreach (GridColumnDescriptor desc in descColl)
            desc.AllowFilter = true;
        //Below is to have a specific column with respect to index
        //this.GridGroupingControl1.TableDescriptor.Columns[0].AllowFilter = false;     
    }
  private void SetGridDataSource(string dataSourceID)
  {
    this.GridGroupingControl1.DataSourceID = dataSourceID;

    this.ResetTableDescriptor();

    //Binding the Grid
    this.GridGroupingControl1.DataBind();
  }
  private void ResetTableDescriptor()
  {
    GridTableDescriptor maintd = this.GridGroupingControl1.TableDescriptor;

    // Calling ResetTableDescriptor is the best way to reset all settings in the TableDescriptor.
    // Setting like user's sorted columns, 
    maintd.ResetTableDescriptor();

    // Some common properties (common to any DataSourceID):
    // This would have been reset due to our call to ResetTableDescriptor above.
    maintd.AllowNew = false;
      
    // PrimaryKeyColumns would have been reset above. We add the right colum here based on the new DataSourceID:

   int j = Int32.Parse(this.DatasourceList.SelectedIndex.ToString());
    switch (j)
    {
      case 0:
        this.GridGroupingControl1.DataSourceID = this.DatasourceList.SelectedValue.ToString();
        maintd.PrimaryKeyColumns.Add("EmployeeID");
        break;
      case 1:
        this.GridGroupingControl1.DataSourceID = this.DatasourceList.SelectedValue.ToString();
        maintd.PrimaryKeyColumns.Add("CustomerID");
        break;
      default:
        this.GridGroupingControl1.DataSourceID = "EmployeesDetails";
        maintd.PrimaryKeyColumns.Add("EmployeeID");
        break;

    }
  }
  protected void DatasourceList_SelectedIndexChanged(object sender, EventArgs e)
  {
    this.SetGridDataSource(this.DatasourceList.SelectedValue.ToString());
  }
  protected void GridGroupingControl1_DataSourceControlRowAdding(object sender, GridDataSourceControlRowAddingEventArgs e)
  {
    e.Cancel = true;
  }
  protected void GridGroupingControl1_DataSourceControlRowDeleting(object sender, GridDataSourceControlRowDeleteEventArgs e)
  {
    e.Cancel = true;
  }
  protected void GridGroupingControl1_DataSourceControlRowUpdating(object sender, GridDataSourceControlRowUpdateEventArgs e)
  {
    e.Cancel = true;
  }
}